#!/usr/bin/perl -w

use lib "/usr/sausalito/perl";
use lib "/usr/sausalito/handlers/base/cache";
use Cache;
use Sauce::Util;
use CCE;
use strict;

my $cce=new CCE(Namespace => "CacheACL");
my $confFile="/etc/squid/squid.conf";
my $blockStart="# -*- COBALT-FILTER-RULES -*-\n";
my $blockEnd="# -*- END-COBALT-FILTER-RULES -*-\n";

$cce->connectfd();
my $obj=$cce->event_object();

my (@ip)=$cce->scalar_to_array($obj->{ipaddr});
my (@domain)=$cce->scalar_to_array($obj->{domains});

my $ip_string = "acl Cips dst ".(join " ",@ip)."\n";
my $domain_string = "acl Cdomains dstdomain ".(join " ",@domain)."\n";
my $mode_string;

if($obj->{mode} eq "whitelist"){
	$mode_string="http_access allow Cips\nhttp_access allow Cdomains\nhttp_access deny all\n";
}elsif($obj->{mode} eq "blacklist"){
	$mode_string="http_access deny Cips\nhttp_access deny Cdomains\nhttp_access allow all\n";
}else{
	$mode_string="http_access allow all\n";
}

my $string=$ip_string.$domain_string.$mode_string;

my $edit=\&editSquid;

Sauce::Util::editfile($confFile,$edit,$blockStart,$string,$blockEnd) ||
($cce->bye("FAIL","[[base-cacheACL.editFile]]") && exit(1));

system("/etc/rc.d/init.d/squid reload > /dev/null 2>&1");
# if (system("/etc/rc.d/init.d/squid reload > /dev/null 2>&1")) {
# 	$cce->bye("FAIL","[[base-cacheACL.restartSquid]]");
# 	exit(1);
# }


$cce->bye("SUCCESS");
exit 0;

sub editSquid{
my($in,$out,$start,$txt,$stop)=@_;

while($_=<$in>){
	if($_ eq $start){
		print $out $start;
		print $out $txt;
		print $out $stop;
		$_=<$in> until $_ eq $stop;
	}else{
		print $out $_;
	}
}
return 1;
}

